//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers   4
#property indicator_color1    clrLimeGreen
#property indicator_color2    clrRed
#property indicator_color3    clrGray
#property indicator_color4    clrGray
#property indicator_width1    2
#property indicator_width2    2
#property indicator_width3    2
#property indicator_width4    2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame            = PERIOD_CURRENT;
extern int                RsiPeriod            = 14;
extern ENUM_APPLIED_PRICE Price                = PRICE_CLOSE;
extern int                PriceSmoothing       = 1;
extern ENUM_MA_METHOD     PriceSmoothingMethod = MODE_EMA;
extern int                AveragePeriod        = 25; 
extern ENUM_MA_METHOD     AverageMethod        = MODE_EMA;
extern double             levelOb              = 80;
extern double             levelOs              = 20;

//
//
//
//
//

double rsi[];
double rsia[];
double LWUp[],LWDn[];
double RWUp[],RWDn[];
double trend1[];
double trend2[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,LWUp); SetIndexStyle(0, DRAW_HISTOGRAM);
	   SetIndexBuffer(1,LWDn); SetIndexStyle(1, DRAW_HISTOGRAM);					
	   SetIndexBuffer(2,RWUp); SetIndexStyle(2, DRAW_HISTOGRAM);
	   SetIndexBuffer(3,RWDn); SetIndexStyle(3, DRAW_HISTOGRAM);	
      SetIndexBuffer(4,rsi);
      SetIndexBuffer(5,rsia);
      SetIndexBuffer(6,trend1);		
	   SetIndexBuffer(7,trend2);	
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName("Rsioma ("+RsiPeriod+","+PriceSmoothing+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars)  { LWUp[0] = limit+1; return(0); }
           if (TimeFrame!=Period())
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     trend1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,Price,PriceSmoothing,PriceSmoothingMethod,AveragePeriod,AverageMethod,levelOb,levelOs,6,y);
                     trend2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RsiPeriod,Price,PriceSmoothing,PriceSmoothingMethod,AveragePeriod,AverageMethod,levelOb,levelOs,7,y);
                     LWUp[i] = EMPTY_VALUE; LWDn[i] = EMPTY_VALUE;
		               RWUp[i] = EMPTY_VALUE; RWDn[i] = EMPTY_VALUE; 
		               if (trend1[i] == 1) { LWUp[i] = High[i]; LWDn[i] = Low[i]; }
                     if (trend1[i] ==-1) { LWDn[i] = High[i]; LWUp[i] = Low[i]; }
                     if (trend2[i] == 1) { RWUp[i] = High[i]; RWDn[i] = Low[i]; }
                     if (trend2[i] ==-1) { RWDn[i] = High[i]; RWUp[i] = Low[i]; }
               }
               return(0);
            }               

   //
   //
   //
   //
   //

      for(i=limit; i>=0; i--) rsi[i] = iRsi(iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,Price,i),RsiPeriod,i);
      for(i=limit; i>=0; i--)
      {
          rsia[i] = iMAOnArray(rsi,0,AveragePeriod,0,AverageMethod,i);
          LWUp[i] = EMPTY_VALUE; LWDn[i] = EMPTY_VALUE;
		    RWUp[i] = EMPTY_VALUE; RWDn[i] = EMPTY_VALUE; 
          trend1[i] = 0;
          trend2[i] = 0;
             if (rsi[i]>rsia[i])  trend1[i] = 1;
             if (rsi[i]<rsia[i])  trend1[i] =-1;
             if (rsi[i]>levelOb)  trend2[i] = 1;
             if (rsi[i]<levelOs)  trend2[i] =-1;
            
             if (trend1[i] == 1) { LWUp[i] = High[i]; LWDn[i] = Low[i]; }
             if (trend1[i] ==-1) { LWDn[i] = High[i]; LWUp[i] = Low[i]; }
             if (trend2[i] == 1) { RWUp[i] = High[i]; RWDn[i] = Low[i]; }
             if (trend2[i] ==-1) { RWDn[i] = High[i]; RWUp[i] = Low[i]; }
      }       
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}